//Efecto recuperación-desvanecimiento de colores con tira leds RGB (fading)

int ledPinR = 13;      //led rojo conectado al pin digital 13
int ledPinV = 12;      //led verde conectado al pin digital 12
int ledPinA = 11;      //led azul conectado al pin digital 11

void setup() {
  pinMode(ledPinR, OUTPUT);  //configura el pin 13 como salida
  pinMode(ledPinV, OUTPUT);  //configura el pin 12 como salida
  pinMode(ledPinA, OUTPUT);  //configura el pin 11 como salida
}

void loop() {
  blanco();     //llama a la función blanco
  rojo();       //llama a la función rojo 
  verde();      //llama a la función verde
  azul();       //llama a la función azul
  amarillo();   //llama a la función amarillo
}

void blanco() {
  //recuperación blanco de un mínimo a un máximo en incremento de 5 unidades
  for (int valor = 0 ; valor <= 255; valor += 5) {  //pone valor en el rango de 0 a 255
    analogWrite(ledPinR, valor);                    //pone en el pin 13 el valor de valor
    analogWrite(ledPinV, valor);                    //pone en el pin 12 el valor de valor
    analogWrite(ledPinA, valor);                    //pone en el pin 11 el valor de valor
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
    //desvanecimiento blanco de un máximo a un mínimo en incremento de 5 unidades
  for (int valor = 255 ; valor >= 0; valor -= 5) {  //pone valor en el rango de 255 a 0
    analogWrite(ledPinR, valor);                    //pone en el pin 13 el valor de valor
    analogWrite(ledPinV, valor);                    //pone en el pin 12 el valor de valor
    analogWrite(ledPinA, valor);                    //pone en el pin 11 el valor de valor
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
}

void rojo() {
  //recuperación rojo de un mínimo a un máximo en incremento de 5 unidades
  for (int valor = 0 ; valor <= 255; valor += 5) {  //pone valor en el rango de 0 a 255
    analogWrite(ledPinR, valor);                    //pone en el pin 13 el valor de valor
    analogWrite(ledPinV, 0);                        //pone en el pin 12 a 0
    analogWrite(ledPinA, 0);                        //pone en el pin 11 a 0
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
    //desvanecimiento rojo de un máximo a un mínimo en incremento de 5 unidades
  for (int valor = 255 ; valor >= 0; valor -= 5) {  //pone valor en el rango de 255 a 0
    analogWrite(ledPinR, valor);                    //pone en el pin 13 el valor de valor
    analogWrite(ledPinV, 0);                        //pone en el pin 12 a 0
    analogWrite(ledPinA, 0);                        //pone en el pin 11 a 0
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
}

void verde() {
  //recuperación verde de un mínimo a un máximo en incremento de 5 unidades
  for (int valor = 0 ; valor <= 255; valor += 5) {  //pone valor en el rango de 0 a 255
    analogWrite(ledPinR, 0);                        //pone en el pin 13 a 0
    analogWrite(ledPinV, valor);                    //pone en el pin 12 el valor de valor
    analogWrite(ledPinA, 0);                        //pone en el pin 11 a 0
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
    //desvanecimiento verde de un máximo a un mínimo en incremento de 5 unidades
  for (int valor = 255 ; valor >= 0; valor -= 5) {  //pone valor en el rango de 255 a 0
    analogWrite(ledPinR, 0);                        //pone en el pin 13 a 0
    analogWrite(ledPinV, valor);                    //pone en el pin 12 el valor de valor
    analogWrite(ledPinA, 0);                        //pone en el pin 11 a 0
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
}

void azul() {
  //recuperación azul de un mínimo a un máximo en incremento de 5 unidades
  for (int valor = 0 ; valor <= 255; valor += 5) {  //pone valor en el rango de 0 a 255
    analogWrite(ledPinR, 0);                        //pone en el pin 13 a 0
    analogWrite(ledPinV, 0);                        //pone en el pin 12 a 0
    analogWrite(ledPinA, valor);                    //pone en el pin 11 el valor de valor
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
    //desvanecimiento azul de un máximo a un mínimo en incremento de 5 unidades
  for (int valor = 255 ; valor >= 0; valor -= 5) {  //pone valor en el rango de 255 a 0
    analogWrite(ledPinR, 0);                        //pone en el pin 13 a 0
    analogWrite(ledPinV, 0);                        //pone en el pin 12 a 0
    analogWrite(ledPinA, valor);                    //pone en el pin 11 el valor de valor
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
}

void amarillo() {
  //recuperación amarillo de un mínimo a un máximo en incremento de 5 unidades
  for (int valor = 0 ; valor <= 255; valor += 5) {  //pone valor en el rango de 0 a 255
    analogWrite(ledPinR, valor);                    //pone en el pin 13 el valor de valor
    analogWrite(ledPinV, valor);                    //pone en el pin 12 el valor de valor
    analogWrite(ledPinA, 0);                        //pone en el pin 11 a 0
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
    //desvanecimiento amarillo de un máximo a un mínimo en incremento de 5 unidades
  for (int valor = 255 ; valor >= 0; valor -= 5) {  //pone valor en el rango de 255 a 0
    analogWrite(ledPinR, valor);                    //pone en el pin 13 el valor de valor
    analogWrite(ledPinV, valor);                    //pone en el pin 12 el valor de valor
    analogWrite(ledPinA, 0);                        //pone en el pin 11 a 0
    delay(50);                                      //pausa de 50 ms para ver el efecto
  }
}
